"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _reactNativeGestureHandler = require("react-native-gesture-handler");

var _reactNativeReanimated = _interopRequireWildcard(require("react-native-reanimated"));

var _Seperator = _interopRequireDefault(require("./Seperator"));

var _styles = _interopRequireDefault(require("./styles"));

var _hooks = require("../../hooks");

var _constants = require("../../constants");

var _constants2 = require("./constants");

var _lodash = _interopRequireDefault(require("lodash.isequal"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const ItemComponent = _constants.IS_IOS ? _reactNative.TouchableOpacity : _reactNativeGestureHandler.TouchableOpacity;

const AnimatedTouchable = _reactNativeReanimated.default.createAnimatedComponent(ItemComponent);

const MenuItemComponent = ({
  item,
  isLast,
  theme
}) => {
  const {
    state
  } = (0, _hooks.useInternal)();
  const borderStyles = (0, _reactNativeReanimated.useAnimatedStyle)(() => {
    const borderBottomColor = theme === 'dark' ? _constants2.BORDER_DARK_COLOR : _constants2.BORDER_LIGHT_COLOR;
    return {
      borderBottomColor,
      borderBottomWidth: isLast ? 0 : 1
    };
  }, [theme, isLast]);
  const textColor = (0, _react.useMemo)(() => {
    return {
      color: item.isTitle ? _constants2.MENU_TITLE_COLOR : item.isDestructive ? _constants2.MENU_TEXT_DESTRUCTIVE_COLOR : theme === 'dark' ? _constants2.MENU_TEXT_DARK_COLOR : _constants2.MENU_TEXT_LIGHT_COLOR
    };
  }, [item, theme]);
  const handleOnPress = (0, _react.useCallback)(() => {
    if (!item.isTitle) {
      if (item.onPress) item.onPress();
      state.value = _constants.CONTEXT_MENU_STATE.END;
    }
  }, [state, item]);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(AnimatedTouchable, {
    onPress: handleOnPress,
    activeOpacity: !item.isTitle ? 0.4 : 1,
    style: [_styles.default.menuItem, borderStyles]
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: [item.isTitle ? _styles.default.menuItemTitleText : _styles.default.menuItemText, textColor]
  }, item.text), !item.isTitle && item.icon && item.icon()), item.withSeperator && /*#__PURE__*/_react.default.createElement(_Seperator.default, {
    theme: theme
  }));
};

const MenuItem = /*#__PURE__*/_react.default.memo(MenuItemComponent, _lodash.default);

var _default = MenuItem;
exports.default = _default;
//# sourceMappingURL=MenuItem.js.map